
Ruby - Feature #1786

unexpected #inspect behaviour

07/18/2009 06:27 PM - evilbrain (Andy Bogdanov)

Status: Closed   

Priority: Normal   

Assignee:    

Target version: 1.9.2   

Description

=begin

It's said in the documentation that #inspect, if not overridden should use #to_s. Instead of that, when not overridden, #inspect uses

#to_s only until the first instance variable assignment, after that it is overridden by interpreter.

~$ cat > test.rb

class MyClass

def to_s() "instance of MyClass" end

def assign

@var = var

self

end

end

~$ irb

irb(main):001:0> load 'test.rb'

=> true

irb(main):002:0> MyClass.new

=> Instance of MyClass

irb(main):003:0> MyClass.new.assign

=> #<MyClass:0x9071620 @val=nil>

Besides that #to_s stays unchanged when it's not overridden and because usually the first instance variable assignment happens in

#initialize in most cases #inspect returns something like #<MyClass:0x9071620 @val=nil> and #to_s returns #MyClass:0x9071620

=end

Related issues:

Related to Ruby - Bug #4453: Overriding #to_s changes #inspect Closed 03/01/2011

History

#1 - 10/21/2009 08:48 AM - rogerdpack (Roger Pack)

=begin

Which versions show this?

-r

=end

#2 - 10/21/2009 09:29 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Rejected

=begin

to_s isn't inspect.

orverride inspect if you want to change it.

=end

#3 - 10/21/2009 06:13 PM - yugui (Yuki Sonoda)

- Category set to doc

- Status changed from Rejected to Open

- Target version set to 1.9.2

=begin

I think it is a bug of rdoc documentation.

=end
#4 - 10/21/2009 07:37 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

=begin

This issue was solved with changeset r25427.

Andy, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

=end

#5 - 10/21/2009 10:12 PM - matz (Yukihiro Matsumoto)

=begin

Hi,

In message "Re: [ruby-core:26193] Feature #1786 unexpected #inspect behaviour"

on Wed, 21 Oct 2009 09:29:53 +0900, Nobuyoshi Nakada redmine@ruby-lang.org writes:

|to_s isn't inspect.

|orverride inspect if you want to change it.

But still, the behavior OP reported is weird.  Redefining #to_s should

not affect inspect, if they are totally different.

I will work on.

      matz.

 =end
